%if 0%{?fedora} || 0%{?rhel} == 6
%global with_bundled 0
%global with_check 1
%global with_unit_test 1
%else
%global with_bundled 0
%global with_check 0
%global with_unit_test 0
%endif

%define debug_package %{nil}
%global with_devel 1
%global with_debug 0

%global provider        github
%global provider_tld    com
%global project         fhs
%global repo            go-netrc
# https://github.com/fhs/go-netrc
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          4ffed54ee5c32ebfb1b8c7c72fc90bb08dc3ff43
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0
Release:        0.3.git%{shortcommit}%{?dist}
Summary:        netrc file parser for Go programming language. 
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# handle upstream relocation
Provides:	golang-googlecode-go-netrc
Obsoletes:	golang-googlecode-go-netrc

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%if ! 0%{?with_bundled}
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} && ! 0%{?with_bundled}
%endif


Provides:      golang(%{import_path}/netrc) = %{version}-%{release}
Provides:      golang(code.google.com/p/go-netrc/netrc) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build
mkdir -p src/github.com/fhs
ln -s ../../../ src/github.com/fhs/go-netrc

%if ! 0%{?with_bundled}
export GOPATH=$(pwd):%{gopath}
%else
export GOPATH=$(pwd):$(pwd)/Godeps/_workspace:%{gopath}
%endif

#%gobuild -o bin/NAME %{import_path}/NAME

%install
install -d -p %{buildroot}%{_bindir}
#install -p -m 0755 bin/NAME %{buildroot}%{_bindir}

# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# perform parallel construction with google path here
install -d -p %{buildroot}/%{gopath}/src/code.google.com/p
ln -s ../../github.com/fhs/go-netrc %{buildroot}/%{gopath}/src/code.google.com/p/go-netrc
echo "%%{gopath}/src/code.google.com/p/go-netrc" >> devel.file-list
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
# demo data file needs a ride
cp -pav netrc/example.netrc %{buildroot}/%{gopath}/src/%{import_path}/netrc/example.netrc
echo "%%{gopath}/src/%%{import_path}/netrc/example.netrc" >> unit-test-devel.file-list
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%gotest %{import_path}/netrc
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
#%{_bindir}/NAME

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%endif

%changelog
* Thu Jun 23 2016 RJ Bergeron <rbergero@gmail.com> - 0-0.1.git4ffed54
- First package for Fedora


* Thu Jun 23 2016 RJ Bergeron <rbergero@gmail.com> - 0-0.2.git4ffed54
- Provide golang-googlecode-go-netrc

* Thu Jun 23 2016 RJ Bergeron <rbergero@gmail.com> - 0-0.3.git4ffed54
- Fix -devel too

